// CTimeExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CTimeExplorer.h"
#include "CTimeExplorerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCTimeExplorerDlg dialog

CCTimeExplorerDlg::CCTimeExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCTimeExplorerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCTimeExplorerDlg)
	c_Seconds = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCTimeExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCTimeExplorerDlg)
	DDX_Control(pDX, IDC_FORMAT, c_Format);
	DDX_Control(pDX, IDC_HEX, c_Hex);
	DDX_Control(pDX, IDC_TIME, c_Time);
	DDX_Control(pDX, IDC_DECIMAL, c_Decimal);
	DDX_Control(pDX, IDC_SPIN_HH, c_SpinHours);
	DDX_Control(pDX, IDC_YY, c_Year);
	DDX_Control(pDX, IDC_STANDARD, c_Standard);
	DDX_Control(pDX, IDC_SPIN_YEAR, c_SpinYear);
	DDX_Control(pDX, IDC_SPIN_SS, c_SpinSeconds);
	DDX_Control(pDX, IDC_SPIN_MON, c_SpinMonth);
	DDX_Control(pDX, IDC_SPIN_MM, c_SpinMinutes);
	DDX_Control(pDX, IDC_SPIN_DAY, c_SpinDay);
	DDX_Control(pDX, IDC_MON, c_Month);
	DDX_Control(pDX, IDC_MM, c_Minutes);
	DDX_Control(pDX, IDC_MAKETIME, c_MakeTime);
	DDX_Control(pDX, IDC_LOCALTIME, c_LocalTIme);
	DDX_Control(pDX, IDC_HH, c_Hours);
	DDX_Control(pDX, IDC_HASH, c_Hash);
	DDX_Control(pDX, IDC_FORMATTED, c_Formatted);
	DDX_Control(pDX, IDC_FMT_UC_Z, c_Format_Z);
	DDX_Control(pDX, IDC_FMT_UC_Y, c_Format_Y);
	DDX_Control(pDX, IDC_FMT_UC_X, c_Format_X);
	DDX_Control(pDX, IDC_FMT_UC_W, c_Format_W);
	DDX_Control(pDX, IDC_FMT_UC_U, c_Format_U);
	DDX_Control(pDX, IDC_FMT_UC_S, c_Format_S);
	DDX_Control(pDX, IDC_FMT_UC_M, c_Format_M);
	DDX_Control(pDX, IDC_FMT_UC_I, c_Format_I);
	DDX_Control(pDX, IDC_FMT_UC_H, c_Format_H);
	DDX_Control(pDX, IDC_FMT_UC_B, c_Format_B);
	DDX_Control(pDX, IDC_FMT_UC_A, c_Format_A);
	DDX_Control(pDX, IDC_FMT_LC_Z, c_Format_z);
	DDX_Control(pDX, IDC_FMT_LC_Y, c_Format_y);
	DDX_Control(pDX, IDC_FMT_LC_X, c_Format_x);
	DDX_Control(pDX, IDC_FMT_LC_W, c_Format_w);
	DDX_Control(pDX, IDC_FMT_LC_P, c_Format_p);
	DDX_Control(pDX, IDC_FMT_LC_M, c_Format_m);
	DDX_Control(pDX, IDC_FMT_LC_J, c_Format_j);
	DDX_Control(pDX, IDC_FMT_LC_D, c_Format_d);
	DDX_Control(pDX, IDC_FMT_LC_C, c_Format_c);
	DDX_Control(pDX, IDC_FMT_LC_B, c_Format_b);
	DDX_Control(pDX, IDC_FMT_LC_A, c_Format_a);
	DDX_Control(pDX, IDC_DAYLIGHT, c_DST);
	DDX_Control(pDX, IDC_DAY, c_Day);
	DDX_Control(pDX, IDC_AUTO, c_AutoDST);
	DDX_Text(pDX, IDC_SS, c_Seconds);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCTimeExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(CCTimeExplorerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_FORMAT, OnChangeFormat)
	ON_BN_CLICKED(IDC_HEX, OnHex)
	ON_BN_CLICKED(IDC_DECIMAL, OnDecimal)
	ON_BN_CLICKED(IDC_MAKETIME, OnMaketime)
	ON_BN_CLICKED(IDC_LOCALTIME, OnLocaltime)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SPACES, OnSpaces)
	ON_EN_CHANGE(IDC_TIME, OnChangeTime)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_FMT_LC_A, IDC_FMT_UC_Z, OnFormatButton)
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnNotifyText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCTimeExplorerDlg message handlers

/****************************************************************************
*                        CCTimeExplorerDlg::expandTime
* Result: void
*       
* Effect: 
*       Expands the 'time' value into the controls
****************************************************************************/

void CCTimeExplorerDlg::expandTime()
    {
     c_SpinYear.SetPos(time.GetYear() - 1900);
     c_SpinMonth.SetPos(time.GetMonth());
     c_SpinDay.SetPos(time.GetDay());
     c_SpinHours.SetPos(time.GetHour());
     c_SpinMinutes.SetPos(time.GetMinute());
     c_SpinSeconds.SetPos(time.GetSecond());
    } // CCTimeExplorerDlg::expandTime

/****************************************************************************
*                       CCTimeExplorerDlg::displayTime
* Result: void
*       
* Effect: 
*       Displays the embedded time_t value in hex or decimal
****************************************************************************/

void CCTimeExplorerDlg::displayTime()
    {
     time_t t = time.GetTime();
     CString s;
     if(c_Decimal.GetCheck() == BST_CHECKED)
	s.Format(_T("%d"), t);
     else
	s.Format(_T("%08x"), t);
     c_Time.SetWindowText(s);
    } // CCTimeExplorerDlg::displayTime

BOOL CCTimeExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CheckRadioButton(IDC_STANDARD, IDC_AUTO, IDC_AUTO);
	CheckRadioButton(IDC_DECIMAL, IDC_HEX, IDC_DECIMAL);
	time = CTime::GetCurrentTime();
	expandTime();
	displayTime();
	c_Format.SetWindowText(_T("")); // force display
	
	c_SpinYear.SetRange(0, 200);  // limit to positive range, but include illegal values
	c_SpinMonth.SetRange(0, 24);  // limit to positive range, but include illegal values
	c_SpinDay.SetRange(0, 48);    // limit to positive range, but include illegal values
	c_SpinHours.SetRange(0, 50);  // limit to positive range, but include illegal values
	c_SpinMinutes.SetRange(0, 90);// limit to positive range, but include illegal values
	c_SpinSeconds.SetRange(0, 90);// limit to positive range, but include illegal values

	tips.Create(this);

	tips.AddTool(&c_Format_a);
	tips.AddTool(&c_Format_b);
	tips.AddTool(&c_Format_c);
	tips.AddTool(&c_Format_d);
	tips.AddTool(&c_Format_j);
	tips.AddTool(&c_Format_m);
	tips.AddTool(&c_Format_p);
	tips.AddTool(&c_Format_w);
	tips.AddTool(&c_Format_x);
	tips.AddTool(&c_Format_y);
	tips.AddTool(&c_Format_z);
	tips.AddTool(&c_Format_A);
	tips.AddTool(&c_Format_B);
	tips.AddTool(&c_Format_H);
	tips.AddTool(&c_Format_I);
	tips.AddTool(&c_Format_M);
	tips.AddTool(&c_Format_S);
	tips.AddTool(&c_Format_U);
	tips.AddTool(&c_Format_W);
	tips.AddTool(&c_Format_X);
	tips.AddTool(&c_Format_Y);
	tips.AddTool(&c_Format_Z);
	tips.SetDelayTime(0); // pop up immediately
	EnableToolTips(TRUE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCTimeExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCTimeExplorerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCTimeExplorerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCTimeExplorerDlg::OnChangeFormat() 
{
 CString fmt;
 CString s;
 c_Format.GetWindowText(fmt);
 if(fmt.Right(1) == _T("%") &&
    fmt.Right(2) != _T("%%"))
    { /* can't format */
     c_Formatted.SetWindowText(_T(""));
     return;
    } /* can't format */

 s = time.Format(fmt);
 c_Formatted.SetWindowText(s);
}

void CCTimeExplorerDlg::OnHex() 
{
 displayTime();
	
}

void CCTimeExplorerDlg::OnDecimal() 
{
 displayTime();	
}

/****************************************************************************
*                       CCTimeExplorerDlg::OnNotifyText
* Inputs:
*       UINT id:
*	NMHDR * pNMHDR:
*	LRESULT *: ignored for this message
* Result: BOOL
*       TRUE if text has been set
*	FALSE if text is not set
* Effect: 
*       Computes the text for the tooltip
*	Reads the text of the control ID which is of the form
*		%x: explanation
*	May modify it if c_Hash is set to
*		%#x: explanation
*	It then converts it to the form
*		%%x: explanation "%x"
*	and uses this to format 'time'
****************************************************************************/

BOOL CCTimeExplorerDlg::OnNotifyText(UINT id, NMHDR * pNMHDR, LRESULT *)
    {
     TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
     UINT nID = pNMHDR->idFrom;
     CWnd * wnd;

     if (pTTT->uFlags & TTF_IDISHWND)
	wnd = CWnd::FromHandle((HWND)nID);
     else
	wnd = GetDlgItem(nID);

     if(wnd->GetDlgCtrlID() < IDC_FMT_LC_A || IDC_FMT_UC_Z < wnd->GetDlgCtrlID())
	return FALSE; // no tooltip for other controls for now

     CString text;
     wnd->GetWindowText(text);
     CString fmt;
     fmt = text.Left(1);
     fmt += _T("%");           // %%
     if(c_Hash.GetCheck() == BST_CHECKED)
	fmt += _T("#");		// %%#
     fmt += text.Mid(1);	// %%#x: explanation
     fmt += _T(" \"%");
     if(c_Hash.GetCheck() == BST_CHECKED)
	fmt += _T("#");
     fmt += text.Mid(1, 1);     // %%#x: explanation "%#x
     fmt += _T("\"");
     CString s = time.Format(fmt);
     lstrcpy(pTTT->szText, s);
     pTTT->hinst = NULL;
     return TRUE;
    } // CCTimeExplorerDlg::OnNotifyText

void CCTimeExplorerDlg::OnMaketime() 
{
 int dst;

 if(c_AutoDST.GetCheck() == BST_CHECKED)
    dst = -1;
 else
 if(c_DST.GetCheck() == BST_CHECKED)
    dst = 1;
 else
    dst = 0;
 
 time = CTime(c_SpinYear.GetPos() + 1900, c_SpinMonth.GetPos(), c_SpinDay.GetPos(),
	      c_SpinHours.GetPos(), c_SpinMinutes.GetPos(), c_SpinSeconds.GetPos(),
	      dst);
 displayTime();
}

void CCTimeExplorerDlg::OnLocaltime() 
{
 expandTime();
}

/****************************************************************************
*                      CCTimeExplorerDlg::OnFormatButton
* Inputs:
*       UINT id: ID of button
* Result: void
*       
* Effect: 
*       Handles button formatting
****************************************************************************/

void CCTimeExplorerDlg::OnFormatButton(UINT id)
    {
     CWnd * wnd = GetDlgItem(id);
     CString text;
     wnd->GetWindowText(text);
     CString fmt;
     fmt = _T("%");
     if(c_Hash.GetCheck() == BST_CHECKED)
	fmt += _T("#");
     fmt += text.Mid(1, 1);
     c_Format.ReplaceSel(fmt);
    } // CCTimeExplorerDlg::OnFormatButton

void CCTimeExplorerDlg::OnCancel() 
{
}

void CCTimeExplorerDlg::OnOK() 
{
}

void CCTimeExplorerDlg::OnClose() 
{
	CDialog::OnOK();
}

void CCTimeExplorerDlg::OnSpaces() 
{
 c_Format.ReplaceSel(_T("  "));
	
}

void CCTimeExplorerDlg::OnChangeTime() 
{
 CString s;
 c_Time.GetWindowText(s);
 time_t t;
 if(c_Hex.GetCheck() == BST_CHECKED)
    t = strtoul(s, NULL, 16);
 else
    t = strtoul(s, NULL, 10);
 time = CTime(t);
}
