// CTimeExplorerDlg.h : header file
//

#if !defined(AFX_CTIMEEXPLORERDLG_H__824C2125_0B69_11D4_9FF4_006067718D04__INCLUDED_)
#define AFX_CTIMEEXPLORERDLG_H__824C2125_0B69_11D4_9FF4_006067718D04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCTimeExplorerDlg dialog

class CCTimeExplorerDlg : public CDialog
{
// Construction
public:
	CCTimeExplorerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CCTimeExplorerDlg)
	enum { IDD = IDD_CTIMEEXPLORER_DIALOG };
	CEdit	c_Format;
	CButton	c_Hex;
	CEdit	c_Time;
	CButton	c_Decimal;
	CSpinButtonCtrl	c_SpinHours;
	CEdit	c_Year;
	CButton	c_Standard;
	CSpinButtonCtrl	c_SpinYear;
	CSpinButtonCtrl	c_SpinSeconds;
	CSpinButtonCtrl	c_SpinMonth;
	CSpinButtonCtrl	c_SpinMinutes;
	CSpinButtonCtrl	c_SpinDay;
	CEdit	c_Month;
	CEdit	c_Minutes;
	CButton	c_MakeTime;
	CButton	c_LocalTIme;
	CEdit	c_Hours;
	CButton	c_Hash;
	CStatic	c_Formatted;
	CButton	c_Format_Z;
	CButton	c_Format_Y;
	CButton	c_Format_X;
	CButton	c_Format_W;
	CButton	c_Format_U;
	CButton	c_Format_S;
	CButton	c_Format_M;
	CButton	c_Format_I;
	CButton	c_Format_H;
	CButton	c_Format_B;
	CButton	c_Format_A;
	CButton	c_Format_z;
	CButton	c_Format_y;
	CButton	c_Format_x;
	CButton	c_Format_w;
	CButton	c_Format_p;
	CButton	c_Format_m;
	CButton	c_Format_j;
	CButton	c_Format_d;
	CButton	c_Format_c;
	CButton	c_Format_b;
	CButton	c_Format_a;
	CButton	c_DST;
	CEdit	c_Day;
	CButton	c_AutoDST;
	CString	c_Seconds;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCTimeExplorerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CTime time;
	void displayTime();
	void expandTime();
	CToolTipCtrl tips;
	// Generated message map functions
	//{{AFX_MSG(CCTimeExplorerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnChangeFormat();
	afx_msg void OnHex();
	afx_msg void OnDecimal();
	afx_msg void OnMaketime();
	afx_msg void OnLocaltime();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnClose();
	afx_msg void OnSpaces();
	afx_msg void OnChangeTime();
	//}}AFX_MSG
	afx_msg void OnFormatButton(UINT id);
	afx_msg BOOL OnNotifyText(UINT id, NMHDR * pNMHDR, LRESULT *);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CTIMEEXPLORERDLG_H__824C2125_0B69_11D4_9FF4_006067718D04__INCLUDED_)
